#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "convert_to_error4xi.py">
#<abstract4xi abstract = "provides function convert_to_error4xi"/>
#<refer4xi reference = "convert_to_error4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "this function is a new one"/>
# -------------------------------------------------------------------------------------------------
#

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'convert_to_error4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # most-common ones
    import weakref
    import array
    import queue
    from traceback import format_exc         
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import convert_to_error
except:
    print("convert_to_error4xi.py *** failed in multiprocessing.util import convert_to_error ***")
#"
#/>
     
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from constant_managers4xi import get_error_manager4xi
from constant_managers4xi import get_traceback_manager4xi
from constant_managers4xi import get_unserializable_manager4xi
from print4xi import print4xi
from remoteerror4xi import RemoteError4Xi
from time4xi import time4xi
#"
#/>


#
# -------------------------------------------------------------------------------------------------
#<function4xi function = "convert-to-error4xi" usage = "
#      managers.py                              
#         _callmethod(self, methodname, args=(), kwds={})
#             raise convert_to_error(kind, result)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def convert_to_error4xi(kind, result):
    '''
    convert_to_error4xi function: converts an error to a corresponding error type 
    '''
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "convert_to_error4xi"
    method2print = "convert_to_error4xi"
    
    message2print = "{started" + "; convert-to-error4xi-started: " + str(convert_to_error4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   

    message2print = "{passed" + "; kind-passed-to-convert-to-error4xi: " + str(kind) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    
    message2print = "{passed" + "; result-passed-to-convert-to-error4xi: " + str(result) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
          
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
              
    if kind == get_error_manager4xi(): #ERROR_MANAGER4XI
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------   
        message2print = "{returning" + "; result-returning-by-convert-to-error4xi: " + str(result) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        
        return result
    elif kind == get_traceback_manager4xi(): #TRACEBACK_MANAGER4XI
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------   
        assert type(result) is str
        
        message2print = "{passing" + "; result-passing-to-RemoteError4Xi-by-convert-to-error4xi: " + str(result) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{returning" + "; RemoteError4Xi-class-returning-by-convert-to-error4xi: " + str(result) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)     
        
        return  RemoteError4Xi(result)
    elif kind == get_unserializable_manager4xi(): #UNSERIALIZABLE_MANAGER4XI
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------   
  
        assert type(result) is str
        
        
        message2print = "{returning" + "; RemoteError4Xi-class-returning-by-convert-to-error4xi: *** unserializable manager ***"  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)     
        
        return RemoteError4Xi('convert_to_error4xi: Unserializable message: %s\n' % result)
    else:
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------   
        message2print = "{returning; error-unrecognized-message-type-returning-by-convert-to-error4xi: " + str(result) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        return ValueError('convert_to_error4xi: Unrecognized message type')
#</function4xi> 
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of convert_to_error4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



